How to customize tree nodes based on levels in Vue TreeView

21 Aug 202624 minutes to read

You can customize the tree nodes based on their levels by adding a custom cssClass to the component and enabling specific styles.

<template>
    <div id="app">
        <div class="control_wrapper">
            <ejs-treeview id='treeview' :fields="fields" :allowEditing='true' cssClass='mytree'></ejs-treeview>
        </div>
        <div class="details">
            <label>Note:</label>
            <div><b>1. The font-weight "Bold" is applied for all the leaf nodes</b></div>
            <div><i>2. The font-weight "Italic" is applied for first level nodes</i></div>
            <div style="color: darkmagenta">3. The color "darkmagenta" is applied for second level nodes</div>
        </div>
    </div>
</template>

<script setup>

    import { TreeViewComponent as EjsTreeview } from "@syncfusion/ej2-vue-navigations";

    var dataSource = [
        {
            id: '01', name: 'Local Disk (C:)', expanded: true,
            subChild: [
                {
                    id: '01-01', name: 'Program Files',
                    subChild: [
                        { id: '01-01-01', name: 'Windows NT' },
                        { id: '01-01-02', name: 'Windows Mail' },
                        { id: '01-01-03', name: 'Windows Photo Viewer' },
                    ]
                },
                {
                    id: '01-02', name: 'Users', expanded: true,
                    subChild: [
                        { id: '01-02-01', name: 'Smith' },
                        { id: '01-02-02', name: 'Public' },
                        { id: '01-02-03', name: 'Admin' },
                    ]
                },
                {
                    id: '01-03', name: 'Windows',
                    subChild: [
                        { id: '01-03-01', name: 'Boot' },
                        { id: '01-03-02', name: 'FileManager' },
                        { id: '01-03-03', name: 'System32' },
                    ]
                },
            ]
        },
        {
            id: '02', name: 'Local Disk (D:)',
            subChild: [
                {
                    id: '02-01', name: 'Personals',
                    subChild: [
                        { id: '02-01-01', name: 'My photo.png' },
                        { id: '02-01-02', name: 'Rental document.docx' },
                        { id: '02-01-03', name: 'Pay slip.pdf' },
                    ]
                },
                {
                    id: '02-02', name: 'Projects',
                    subChild: [
                        { id: '02-02-01', name: 'ASP Application' },
                        { id: '02-02-02', name: 'TypeScript Application' },
                        { id: '02-02-03', name: 'React Application' },
                    ]
                },
                {
                    id: '02-03', name: 'Office',
                    subChild: [
                        { id: '02-03-01', name: 'Work details.docx' },
                        { id: '02-03-02', name: 'Weekly report.docx' },
                        { id: '02-03-03', name: 'Wish list.csv' },
                    ]
                },
            ]
        },
        {
            id: '03', name: 'Local Disk (E:)', icon: 'folder',
            subChild: [
                {
                    id: '03-01', name: 'Pictures',
                    subChild: [
                        { id: '03-01-01', name: 'Wind.jpg' },
                        { id: '03-01-02', name: 'Stone.jpg' },
                        { id: '03-01-03', name: 'Home.jpg' },
                    ]
                },
                {
                    id: '03-02', name: 'Documents',
                    subChild: [
                        { id: '03-02-01', name: 'Environment Pollution.docx' },
                        { id: '03-02-02', name: 'Global Warming.ppt' },
                        { id: '03-02-03', name: 'Social Network.pdf' },
                    ]
                },
                {
                    id: '03-03', name: 'Study Materials',
                    subChild: [
                        { id: '03-03-01', name: 'UI-Guide.pdf' },
                        { id: '03-03-02', name: 'Tutorials.zip' },
                        { id: '03-03-03', name: 'TypeScript.7z' },
                    ]
                },
            ]
        }
    ];

    const fields = { dataSource: dataSource, id: 'id', text: 'name', child: 'subChild' };

</script>

<style>
    @import "../node_modules/@syncfusion/ej2-base/styles/material.css";
    @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

    .control_wrapper {
        display: block;
        max-width: 400px;
        max-height: 350px;
        margin: auto;
        overflow: auto;
        border: 1px solid #dddddd;
        border-radius: 3px;
    }

    #display {
        max-width: 500px;
        margin: auto;
        padding: 10px;
    }

    #app {
        width: 350px;
        margin: 0 auto;
    }

    .details {
        padding-left: 10px;
    }

    /*apply custom css to first level*/
    .mytree .e-level-1>.e-text-content .e-list-text {
        font-style: italic;
    }

    /*apply custom css to second level*/
    .mytree .e-level-2>.e-text-content .e-list-text {
        color: darkmagenta;
    }

    /*apply custom css to all the leaf nodes*/
    .mytree .e-level-3>.e-text-content .e-list-text {
        font-weight: bold;
    }
</style>
<template>
    <div id="app">
        <div class="control_wrapper">
            <ejs-treeview id='treeview' :fields="fields" :allowEditing='true' cssClass='mytree'></ejs-treeview>
        </div>
        <div class="details">
            <label>Note:</label>
            <div><b>1. The font-weight "Bold" is applied for all the leaf nodes</b></div>
            <div><i>2. The font-weight "Italic" is applied for first level nodes</i></div>
            <div style="color: darkmagenta">3. The color "darkmagenta" is applied for second level nodes</div>
        </div>
    </div>
</template>

<script>

    import { TreeViewComponent } from "@syncfusion/ej2-vue-navigations";

    export default {
        name: "App",
        components: {
            "ejs-treeview": TreeViewComponent
        },
        data() {
            var dataSource = [
                {
                    id: '01', name: 'Local Disk (C:)', expanded: true,
                    subChild: [
                        {
                            id: '01-01', name: 'Program Files',
                            subChild: [
                                { id: '01-01-01', name: 'Windows NT' },
                                { id: '01-01-02', name: 'Windows Mail' },
                                { id: '01-01-03', name: 'Windows Photo Viewer' },
                            ]
                        },
                        {
                            id: '01-02', name: 'Users', expanded: true,
                            subChild: [
                                { id: '01-02-01', name: 'Smith' },
                                { id: '01-02-02', name: 'Public' },
                                { id: '01-02-03', name: 'Admin' },
                            ]
                        },
                        {
                            id: '01-03', name: 'Windows',
                            subChild: [
                                { id: '01-03-01', name: 'Boot' },
                                { id: '01-03-02', name: 'FileManager' },
                                { id: '01-03-03', name: 'System32' },
                            ]
                        },
                    ]
                },
                {
                    id: '02', name: 'Local Disk (D:)',
                    subChild: [
                        {
                            id: '02-01', name: 'Personals',
                            subChild: [
                                { id: '02-01-01', name: 'My photo.png' },
                                { id: '02-01-02', name: 'Rental document.docx' },
                                { id: '02-01-03', name: 'Pay slip.pdf' },
                            ]
                        },
                        {
                            id: '02-02', name: 'Projects',
                            subChild: [
                                { id: '02-02-01', name: 'ASP Application' },
                                { id: '02-02-02', name: 'TypeScript Application' },
                                { id: '02-02-03', name: 'React Application' },
                            ]
                        },
                        {
                            id: '02-03', name: 'Office',
                            subChild: [
                                { id: '02-03-01', name: 'Work details.docx' },
                                { id: '02-03-02', name: 'Weekly report.docx' },
                                { id: '02-03-03', name: 'Wish list.csv' },
                            ]
                        },
                    ]
                },
                {
                    id: '03', name: 'Local Disk (E:)', icon: 'folder',
                    subChild: [
                        {
                            id: '03-01', name: 'Pictures',
                            subChild: [
                                { id: '03-01-01', name: 'Wind.jpg' },
                                { id: '03-01-02', name: 'Stone.jpg' },
                                { id: '03-01-03', name: 'Home.jpg' },
                            ]
                        },
                        {
                            id: '03-02', name: 'Documents',
                            subChild: [
                                { id: '03-02-01', name: 'Environment Pollution.docx' },
                                { id: '03-02-02', name: 'Global Warming.ppt' },
                                { id: '03-02-03', name: 'Social Network.pdf' },
                            ]
                        },
                        {
                            id: '03-03', name: 'Study Materials',
                            subChild: [
                                { id: '03-03-01', name: 'UI-Guide.pdf' },
                                { id: '03-03-02', name: 'Tutorials.zip' },
                                { id: '03-03-03', name: 'TypeScript.7z' },
                            ]
                        },
                    ]
                }
            ];
            return {
                fields: { dataSource: dataSource, id: 'id', text: 'name', child: 'subChild' },
            }
        }
    }
</script>

<style>
    @import "../node_modules/@syncfusion/ej2-base/styles/material.css";
    @import "../node_modules/@syncfusion/ej2-vue-navigations/styles/material.css";

    .control_wrapper {
        display: block;
        max-width: 400px;
        max-height: 350px;
        margin: auto;
        overflow: auto;
        border: 1px solid #dddddd;
        border-radius: 3px;
    }

    #display {
        max-width: 500px;
        margin: auto;
        padding: 10px;
    }

    #app {
        width: 350px;
        margin: 0 auto;
    }

    .details {
        padding-left: 10px;
    }

    /*apply custom css to first level*/
    .mytree .e-level-1>.e-text-content .e-list-text {
        font-style: italic;
    }

    /*apply custom css to second level*/
    .mytree .e-level-2>.e-text-content .e-list-text {
        color: darkmagenta;
    }

    /*apply custom css to all the leaf nodes*/
    .mytree .e-level-3>.e-text-content .e-list-text {
        font-weight: bold;
    }
</style>

How to customize tree node levels in Angular Tree View

31 Aug 202615 minutes to read

The TreeView component allows you to apply different visual styles to nodes based on their hierarchical level within the tree structure. This level-based customization enables you to create visually distinct representations for parent nodes, child nodes, and deeply nested items, enhancing the user interface and improving content organization.

Level-based customization works by adding a custom CSS class to the TreeView component through the cssClass property, then targeting specific tree levels using CSS selectors. The TreeView automatically assigns level-specific classes to nodes, which you can leverage to apply targeted styling based on the node’s position in the hierarchy.

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { TreeViewModule } from '@syncfusion/ej2-angular-navigations'
import { Component } from '@angular/core';

@Component({
    imports: [
        FormsModule, TreeViewModule
    ],
    standalone: true,
    selector: 'app-container',
    template: `<div id='treeparent'><ejs-treeview id='treeElement' #treevalidate [fields]='field' [cssClass]='cssClass'></ejs-treeview></div>
                <div class="details">
                    <label>Note:</label>
                       <div><b>1. The font-weight "Bold" is applied for all the leaf nodes</b></div>
                       <div><i>2. The font-weight "Italic" is applied for first level nodes</i></div>
                       <div style="color: darkmagenta">3. The color "darkmagenta" is applied for second level nodes</div>
                    </div>`
})

export class AppComponent {
    // Hierarchical data source for TreeView component
    public hierarchicalData: Object[] = [
        {
            id: '01', name: 'Local Disk (C:)', expanded: true,
            subChild: [
                {
                    id: '01-01', name: 'Program Files',
                    subChild: [
                        { id: '01-01-01', name: 'Windows NT' },
                        { id: '01-01-02', name: 'Windows Mail' },
                        { id: '01-01-03', name: 'Windows Photo Viewer' },
                    ]
                },
                {
                    id: '01-02', name: 'Users', expanded: true,
                    subChild: [
                        { id: '01-02-01', name: 'Smith' },
                        { id: '01-02-02', name: 'Public' },
                        { id: '01-02-03', name: 'Admin' },
                    ]
                },
                {
                    id: '01-03', name: 'Windows',
                    subChild: [
                        { id: '01-03-01', name: 'Boot' },
                        { id: '01-03-02', name: 'FileManager' },
                        { id: '01-03-03', name: 'System32' },
                    ]
                },
            ]
        },
        {
            id: '02', name: 'Local Disk (D:)',
            subChild: [
                {
                    id: '02-01', name: 'Personals',
                    subChild: [
                        { id: '02-01-01', name: 'My photo.png' },
                        { id: '02-01-02', name: 'Rental document.docx' },
                        { id: '02-01-03', name: 'Pay slip.pdf' },
                    ]
                },
                {
                    id: '02-02', name: 'Projects',
                    subChild: [
                        { id: '02-02-01', name: 'ASP Application' },
                        { id: '02-02-02', name: 'TypeScript Application' },
                        { id: '02-02-03', name: 'React Application' },
                    ]
                },
                {
                    id: '02-03', name: 'Office',
                    subChild: [
                        { id: '02-03-01', name: 'Work details.docx' },
                        { id: '02-03-02', name: 'Weekly report.docx' },
                        { id: '02-03-03', name: 'Wish list.csv' },
                    ]
                },
            ]
        },
        {
            id: '03', name: 'Local Disk (E:)', icon: 'folder',
            subChild: [
                {
                    id: '03-01', name: 'Pictures',
                    subChild: [
                        { id: '03-01-01', name: 'Wind.jpg' },
                        { id: '03-01-02', name: 'Stone.jpg' },
                        { id: '03-01-03', name: 'Home.jpg' },
                    ]
                },
                {
                    id: '03-02', name: 'Documents',
                    subChild: [
                        { id: '03-02-01', name: 'Environment Pollution.docx' },
                        { id: '03-02-02', name: 'Global Warming.ppt' },
                        { id: '03-02-03', name: 'Social Network.pdf' },
                    ]
                },
                {
                    id: '03-03', name: 'Study Materials',
                    subChild: [
                        { id: '03-03-01', name: 'UI-Guide.pdf' },
                        { id: '03-03-02', name: 'Tutorials.zip' },
                        { id: '03-03-03', name: 'TypeScript.7z' },
                    ]
                },
            ]
        }
    ];
    // Mapping TreeView fields property with data source properties
    public field: Object = { dataSource: this.hierarchicalData, id: 'id', text: 'name', child: 'subChild' };
    public cssClass: string = 'mytree';
}
@import 'node_modules/@syncfusion/ej2-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-inputs/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-buttons/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-base/styles/material3.css';
@import 'node_modules/@syncfusion/ej2-angular-navigations/styles/material3.css';

#treeparent {
    display: block;
    max-width: 400px;
    max-height: 320px;
    margin: auto;
    overflow: auto;
    border: 1px solid #dddddd;
    border-radius: 3px;
}

.details {
    padding-left: 10px;
}

/*apply custom css to first level*/
.mytree .e-level-1 > .e-text-content .e-list-text {
    font-style: italic;
}

/*apply custom css to second level*/
.mytree .e-level-2 > .e-text-content .e-list-text {
color: darkmagenta;
}

/*apply custom css to all the leaf nodes*/
.mytree .e-level-3 > .e-text-content .e-list-text {
font-weight: bold;
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

How to customize tree nodes by level in React

10 Aug 202624 minutes to read

You can customize the tree nodes level wise by adding custom cssClass to the component and enabling styles.

import * as ReactDOM from 'react-dom';
import * as React from 'react';
import { TreeViewComponent } from '@syncfusion/ej2-react-navigations';
import { enableRipple } from '@syncfusion/ej2-base';
enableRipple(true);
function App() {
    // Hierarchical data source for TreeView component
    let hierarchicalData = [
        { id: '01', name: 'Local Disk (C:)', expanded: true,
            subChild: [
                {
                    id: '01-01', name: 'Program Files',
                    subChild: [
                        { id: '01-01-01', name: 'Windows NT' },
                        { id: '01-01-02', name: 'Windows Mail' },
                        { id: '01-01-03', name: 'Windows Photo Viewer' },
                    ]
                },
                {
                    id: '01-02', name: 'Users', expanded: true,
                    subChild: [
                        { id: '01-02-01', name: 'Smith' },
                        { id: '01-02-02', name: 'Public' },
                        { id: '01-02-03', name: 'Admin' },
                    ]
                },
                {
                    id: '01-03', name: 'Windows',
                    subChild: [
                        { id: '01-03-01', name: 'Boot' },
                        { id: '01-03-02', name: 'FileManager' },
                        { id: '01-03-03', name: 'System32' },
                    ]
                },
            ]
        },
        {
            id: '02', name: 'Local Disk (D:)',
            subChild: [
                {
                    id: '02-01', name: 'Personals',
                    subChild: [
                        { id: '02-01-01', name: 'My photo.png' },
                        { id: '02-01-02', name: 'Rental document.docx' },
                        { id: '02-01-03', name: 'Pay slip.pdf' },
                    ]
                },
                {
                    id: '02-02', name: 'Projects',
                    subChild: [
                        { id: '02-02-01', name: 'ASP Application' },
                        { id: '02-02-02', name: 'TypeScript Application' },
                        { id: '02-02-03', name: 'React Application' },
                    ]
                },
                {
                    id: '02-03', name: 'Office',
                    subChild: [
                        { id: '02-03-01', name: 'Work details.docx' },
                        { id: '02-03-02', name: 'Weekly report.docx' },
                        { id: '02-03-03', name: 'Wish list.csv' },
                    ]
                },
            ]
        },
        {
            id: '03', name: 'Local Disk (E:)', icon: 'folder',
            subChild: [
                {
                    id: '03-01', name: 'Pictures',
                    subChild: [
                        { id: '03-01-01', name: 'Wind.jpg' },
                        { id: '03-01-02', name: 'Stone.jpg' },
                        { id: '03-01-03', name: 'Home.jpg' },
                    ]
                },
                {
                    id: '03-02', name: 'Documents',
                    subChild: [
                        { id: '03-02-01', name: 'Environment Pollution.docx' },
                        { id: '03-02-02', name: 'Global Warming.ppt' },
                        { id: '03-02-03', name: 'Social Network.pdf' },
                    ]
                },
                {
                    id: '03-03', name: 'Study tailwind3s',
                    subChild: [
                        { id: '03-03-01', name: 'UI-Guide.pdf' },
                        { id: '03-03-02', name: 'Tutorials.zip' },
                        { id: '03-03-03', name: 'TypeScript.7z' },
                    ]
                },
            ]
        }
    ];
    let fields = { dataSource: hierarchicalData, id: 'id', text: 'name', child: 'subChild' };
    let cssClass = 'mytree';
    return (<div className='control-pane'>
        <div className='control-section'>
        <div className='control_wrapper'>
            {/* Render TreeView */}
            <TreeViewComponent fields={fields} cssClass={cssClass}/>            
        </div>
        </div>
        <div className="details">
                <label>Note:</label>
                 <div><b>1. The font-weight "Bold" is applied for all the leaf nodes</b></div>
                 <div><i>2. The font-weight "Italic" is applied for first level nodes</i></div>
                 <div>3. The color "darkmagenta" is applied for second level nodes</div>
            </div>
      </div>);
}
export default App;
ReactDOM.render(<App />, document.getElementById('sample'));
import * as ReactDOM from 'react-dom';
import * as React from 'react';
import {TreeViewComponent, NodeEditEventArgs} from '@syncfusion/ej2-react-navigations';
import {enableRipple} from '@syncfusion/ej2-base';
enableRipple(true);

function App() {

// Hierarchical data source for TreeView component
let hierarchicalData: { [key: string]: Object }[] = [
    { id: '01', name: 'Local Disk (C:)', expanded: true,
        subChild: [
            {
                id: '01-01', name: 'Program Files',
                subChild: [
                    { id: '01-01-01', name: 'Windows NT' },
                    { id: '01-01-02', name: 'Windows Mail' },
                    { id: '01-01-03', name: 'Windows Photo Viewer' },
                ]
            },
            {
                id: '01-02', name: 'Users', expanded: true,
                subChild: [
                    { id: '01-02-01', name: 'Smith' },
                    { id: '01-02-02', name: 'Public' },
                    { id: '01-02-03', name: 'Admin' },
                ]
            },
            {
                id: '01-03', name: 'Windows',
                subChild: [
                    { id: '01-03-01', name: 'Boot' },
                    { id: '01-03-02', name: 'FileManager' },
                    { id: '01-03-03', name: 'System32' },
                ]
            },
        ]
    },
    {
        id: '02', name: 'Local Disk (D:)',
        subChild: [
            {
                id: '02-01', name: 'Personals',
                subChild: [
                    { id: '02-01-01', name: 'My photo.png' },
                    { id: '02-01-02', name: 'Rental document.docx' },
                    { id: '02-01-03', name: 'Pay slip.pdf' },
                ]
            },
            {
                id: '02-02', name: 'Projects',
                subChild: [
                    { id: '02-02-01', name: 'ASP Application' },
                    { id: '02-02-02', name: 'TypeScript Application' },
                    { id: '02-02-03', name: 'React Application' },
                ]
            },
            {
                id: '02-03', name: 'Office',
                subChild: [
                    { id: '02-03-01', name: 'Work details.docx' },
                    { id: '02-03-02', name: 'Weekly report.docx' },
                    { id: '02-03-03', name: 'Wish list.csv' },
                ]
            },
        ]
    },
    {
        id: '03', name: 'Local Disk (E:)', icon: 'folder',
        subChild: [
            {
                id: '03-01', name: 'Pictures',
                subChild: [
                    { id: '03-01-01', name: 'Wind.jpg' },
                    { id: '03-01-02', name: 'Stone.jpg' },
                    { id: '03-01-03', name: 'Home.jpg' },
                ]
            },
            {
                id: '03-02', name: 'Documents',
                    subChild: [
                    { id: '03-02-01', name: 'Environment Pollution.docx' },
                    { id: '03-02-02', name: 'Global Warming.ppt' },
                    { id: '03-02-03', name: 'Social Network.pdf' },
                ]
            },
            {
                id: '03-03', name: 'Study tailwind3s',
                subChild: [
                    { id: '03-03-01', name: 'UI-Guide.pdf' },
                    { id: '03-03-02', name: 'Tutorials.zip' },
                    { id: '03-03-03', name: 'TypeScript.7z' },
                ]
            },
        ]
    }
];
let fields: object = { dataSource: hierarchicalData, id: 'id', text: 'name', child: 'subChild' };

let cssClass: string = 'mytree';

    return (
      <div className = 'control-pane'>
        <div className='control-section'>
        <div className='control_wrapper'>
            {/* Render TreeView */}
            <TreeViewComponent fields={fields} cssClass={cssClass} />
        </div>
        </div>
            <div className="details">
                <label>Note:</label>
                 <div><b>1. The font-weight "Bold" is applied for all the leaf nodes</b></div>
                 <div><i>2. The font-weight "Italic" is applied for first level nodes</i></div>
                 <div>3. The color "darkmagenta" is applied for second level nodes</div>
            </div>
      </div>
    )
}
export default App;
ReactDOM.render(<App />, document.getElementById('sample'));
<!DOCTYPE html>
<html lang="en">

<head>
    <title>Syncfusion React TreeView</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <meta name="description" content="Essential JS 2 for React Components" />
    <meta name="author" content="Syncfusion" />
    <link href="style.css" rel="stylesheet"/>
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-base/styles/tailwind3.css" rel="stylesheet" />
    <link href="https://cdn.syncfusion.com/ej2/34.2.2/ej2-react-navigations/styles/tailwind3.css" rel="stylesheet" />
    <script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.38/system.js"></script>
    <script src="systemjs.config.js"></script>
</head>

<body>
    <div id='treeparent'>
        <div id='sample'>
            <div id='loader'>Loading....</div>
        </div>
    </div>
</body>

</html>
#loader {
    color: #008cff;
    height: 40px;
    left: 45%;
    position: absolute;
    top: 45%;
    width: 30%;
}

.control_wrapper {
    display: block;
    max-width: 350px;
    max-height: 350px;
    margin: auto;
    overflow: auto;
    border: 1px solid #dddddd;
    border-radius: 3px;
}

.details {
  padding-left: 10px;
}

/*apply custom css to first level*/
.mytree .e-level-1 > .e-text-content .e-list-text{
  font-style: italic;
}

/*apply custom css to second level*/
.mytree .e-level-2 > .e-text-content .e-list-text {
  color: darkmagenta;
}

/*apply custom css to all the leaf nodes*/
.mytree .e-level-3 > .e-text-content .e-list-text {
  font-weight: bold;
}